package dicewars.util;

/*
 * A Point in a Cartesian coordinate system
 *
 * Nothing to do here
 */

import static java.lang.Math.sqrt;

public class Point {

    public final double x, y;  // No getters

    public Point(double x, double y) {
        this.x = x;
        this.y = y;
    }

    public double distance(Point other) {
        return sqrt((x - other.x) * (x - other.x) + (y - other.y) * (y - other.y));
    }

    @Override
    public boolean equals(Object o) {  // Must have because we store hex's in collections!
        if (this == o) {
            return true;
        }
        if (!(o instanceof Point)) {
            return false;
        }
        Point point = (Point) o;
        if (Double.compare(point.x, x) != 0) {
            return false;
        }
        return Double.compare(point.y, y) == 0;
    }

    @Override
    public int hashCode() {   // Must have because we store hex's in maps!
        int result;
        long temp;
        temp = Double.doubleToLongBits(x);
        result = (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(y);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }

    @Override
    public String toString() {
        return "Point{" +
                "x=" + x +
                ", y=" + y +
                '}';
    }
}

