package huntingOUT;

import javafx.animation.AnimationTimer;
import javafx.application.Application;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.input.KeyEvent;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafx.stage.Stage;

import static java.lang.System.out;
import static hunting.Hunting.*;

/*
 * The GUI parts and event handling of "huntingOUT" game.
 * To run the game run this
 *
 * Note: No game logic here!
 *
 * Note: The coordinate system has y-axis pointing down!
 *
 */
public class HuntingGUI extends Application {

    private Hunting hunting;   // The model

    // -- Handle keyboard -----------------------

    private void keyPressed(KeyEvent event) {
        switch (event.getCode()) {
            case LEFT:
                out.println("left");
                break;
            case RIGHT:
                out.println("right");
                break;
            case UP:
                out.println("up");
                break;
            case DOWN:
                out.println("down");
                break;
            default:

        }
    }

    private void keyReleased(KeyEvent event) {

    }


    @Override
    public void init() {
        Hero hero = new Hero(WIDTH / 2, HEIGHT / 2, CHARACTER_WIDTH, CHARACTER_HEIGHT);

    }

    // --------- Render the model ------------------

    private void renderGame(GraphicsContext g) {
        g.clearRect(0, 0, WIDTH, HEIGHT);
        Paint old = g.getFill();
        g.setFill(Color.CADETBLUE);

        double x = hunting.getHero().getMinX();
        double y = hunting.getHero().getMinY();
        g.fillOval(x, y,
                hunting.getHero().getMaxX() - x, hunting.getHero().getMaxY() - y);

        x = hunting.getEnemy().getMinX();
        y = hunting.getEnemy().getMinY();
        g.setFill(Color.BROWN);
        g.fillRect(x, y,
                hunting.getEnemy().getMaxX() - x, hunting.getEnemy().getMaxY() - y);

        g.setFill(old);
    }


    // --------  JavaFX graphics, timer and event handling -----------------------

    @Override
    public void start(Stage primaryStage) throws Exception {

        Group root = new Group();
        Canvas canvas = new Canvas(WIDTH, HEIGHT);
        root.getChildren().addAll(canvas);
        GraphicsContext gc = canvas.getGraphicsContext2D();

        // The game loop, update model, render model ...
        AnimationTimer timer = new AnimationTimer() {
            // Param not used
            public void handle(long currentNanoTime) {
                hunting.update();
                renderGame(gc);

            }
        };
        Scene scene = new Scene(root);
        scene.setOnKeyPressed(this::keyPressed);    // Key listener
        scene.setOnKeyReleased(this::keyReleased);  // Key listener
        primaryStage.setScene(scene);
        primaryStage.setTitle("Hunting");
        primaryStage.show();
        timer.start();    // Start game
    }

    public static void main(String[] args) {
        launch(args);
    }
}
