package exercises.recursion;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import static java.lang.System.exit;
import static java.lang.System.out;

/*
   Recursion for combinatorial problems

   See: https://en.wikipedia.org/wiki/Permutation
   See: https://en.wikipedia.org/wiki/Combination
 */
public class Permutations {

    public static void main(String[] args) {
        new Permutations().program();
    }

    void program() {
        // Create method for recursive permutation (Optional: nice if they where generic)
       /* List<String> perms = permutations("12345");
        out.println(perms.size() == 120);
        out.println(sampleCheck(perms));
        */

        // Same as above but using a list
        /*
        List<Integer> is = new ArrayList<>(Arrays.asList(1,2,3,4,5));
        List<List<Integer>> isPerms = permutations(is);   // permutations(is,0);  // To use generic
        out.println(isPerms);
        */

         // Create method for recursive combinations
       /* List<String> combs = combinations("12345");
        out.println(combs.size() == 32);
        // Should look like [, 1, 2, 12, 3, 13, 23, 123, 4, 14, 24, 124, 34, 134, 234, 123, ..., 1345, 2345, 12345]
        out.println( combs );  // Inspect
        */

    }

    // Some sampling to check there's only one of each (should only be one)
    boolean sampleCheck(List<String> perms) {
        // Remove some
        perms.removeAll(Arrays.asList(new String[]{"12345", "32415", "52431", "35142"}));
        // Shouldn't find them
        return perms.indexOf("12345") < 0 && perms.indexOf("32415") < 0
                && perms.indexOf("32415") < 0 && perms.indexOf("35142") < 0;
    }

    // ----- Recursion (inefficient solutions, recalculating) --------------

    // Pseudo code to help below!

    /*
    procedure all_permutations(S)
    if length(S) == 1
        return the element as a length-one permutation
    else
        all_perm = []
        for each row in S.in_sorted_order
            S1 = S - {row}
            for each P in all_permutations(S1)
                all_perm += [row] + P
        return all_perm
    */

    /*
    procedure all_combinations(S)
    if length(S) == 0
        return {}
    else
        all_comb = {}
        row = some element of S
        Sx = S-{row}
        for each C in all_combinations(Sx)
            all_comb += C
            all_comb += {row} ∪ C
        return all_comb
    */






}